#include <msp/gl/renderer.h>
#include "vehiclepart.h"

using namespace Msp;

namespace R2C2 {

VehiclePart3D::VehiclePart3D(const Vehicle3D &v, const GL::Object &o):
	GL::ObjectInstance(o),
	vehicle(v)
{ }

void VehiclePart3D::render(GL::Renderer &renderer, const GL::Tag &tag) const
{
	if(!vehicle.is_visible())
		return;

	ObjectInstance::render(renderer, tag);
}

void VehiclePart3D::setup_render(GL::Renderer &renderer, const GL::Tag &) const
{
	renderer.matrix_stack() *= matrix;
}

} // namespace R2C2
