#ifndef TRAINVIEW_H_
#define TRAINVIEW_H_

#include <msp/gl/renderbuffer.h>
#include <msp/gl/framebuffer.h>
#include <msp/gl/texture2d.h>
#include <msp/gltk/toggle.h>
#include "libr2c2/train.h"
#include "dynamicdialog.h"

class TrainView: public DynamicDialog
{
public:
	enum Mode
	{
		ROOF,
		SIDE,
		HEAD
	};

private:
	const R2C2::Train &train;
	Msp::GLtk::Toggle *tgl_forward;
	Mode mode;
	bool forward;
	Msp::GL::Framebuffer fbo;
	Msp::GL::Texture2D tex;
	Msp::GL::Renderbuffer depth;
	R2C2::View3D view;

public:
	TrainView(Engineer &, const R2C2::Train &);

	void set_mode(Mode);
private:
	void ui_mode_toggled(bool, Mode);
public:
	void set_forward(bool);
	virtual void update();
};

#endif
