#include <msp/geometry/circle.h>
#include <msp/geometry/extrudedshape.h>
#include <msp/geometry/transformedshape.h>
#include "signaltype.h"

using namespace std;
using namespace Msp;

namespace R2C2 {

SignalType::SignalType()
{
	shape = new Geometry::TransformedShape<float, 3>(
		Geometry::ExtrudedShape<float, 3>(Geometry::Circle<float>(0.01), 0.12),
		Transform::translation(Vector(0, -0.035, 0.06)));
}


SignalType::Loader::Loader(SignalType &st):
	DataFile::DerivedObjectLoader<SignalType, ObjectType::Loader>(st)
{
	add("indication",  &Loader::indication);
	add("object",      &SignalType::object);
}

void SignalType::Loader::indication(const string &n)
{
	Indication ind;
	ind.name = n;
	load_sub(ind);
	obj.indications.push_back(ind);
}


SignalType::Indication::Loader::Loader(Indication &i):
	ObjectLoader<Indication>(i)
{
	add("aspect",      &Indication::aspect);
	add("free_blocks", &Indication::free_blocks);
}

} // namespace R2C2
