#ifndef LIBR2C2_TRACKATTACHMENT_H_
#define LIBR2C2_TRACKATTACHMENT_H_

#include "object.h"
#include "track.h"
#include "trackoffsetiter.h"

namespace R2C2 {

class TrackAttachment: public Object, public sigc::trackable
{
protected:
	TrackOffsetIter track;

	TrackAttachment(Layout &);
public:
	virtual ~TrackAttachment();

	const TrackOffsetIter &get_track_iter() const { return track; }
	Track *get_track() const { return track.track(); }
	unsigned get_entry() const { return track.entry(); }
	float get_offset() const { return track.offset(); }
	float get_offset_from_endpoint(unsigned) const;
protected:
	void attach_to(const TrackOffsetIter &);
	void attach_to_closest(float);
	float find_offset(const TrackIter &, const Vector &);

public:
	virtual Track *get_parent() const { return track.track(); }

private:
	void object_removed(Object &);
};

} // namespace R2C2

#endif
